% De Winter, J. C. F., Dodou, D., & Wieringa, P. A. (2009). Exploratory factor analysis with small sample sizes. Multivariate Behavioral Research, 44, 147-181.

close all;clear all;clc %#ok<CLALL>
load('BFI.mat')
disp(['Total sample size = ' num2str(length(X))])
REPS=100000;
LL=size(X,1);
F1=[1 6  11 16 21 26 31 36];         % extraversion
F5=[5 10 15 20 25 30 35 40 41 44];   % openness
temp=[F1 F5];
X=X(:,temp);
EVs=NaN(REPS,length(temp));
    N=39;
for i=1:REPS
    S=ceil(rand(ceil(N*1.5))*LL); S=unique(S);temp=randperm(length(S));temp=temp(1:N);S=S(temp); % draw a random sample with replacement
    eR2=corrcoef(X(S,:));eigR=sort(eig(eR2));
    EVs(i,:)=eigR;
end
%%
figure;hold on;box on
plot(prctile(EVs(:,end:-1:1),95),'k--o','markerfacecolor','w','markersize',10)
plot(median(EVs(:,end:-1:1)),'k-o','markerfacecolor','k','markersize',10)
plot(prctile(EVs(:,end:-1:1),5),'k--o','markerfacecolor',[.5 .5 .5],'markersize',10)
set(gca,'xtick',1:2:17,'xlim',[1 18])
legend('P95','P50','P5','location','northeast')
xlabel('Factor number');ylabel('Eigenvalue')
h = findobj(gcf,'FontName','Helvetica');set(h,'FontSize',16)
