% De Winter, J. C. F., Dodou, D., & Wieringa, P. A. (2009). Exploratory factor analysis with small sample sizes. Multivariate Behavioral Research, 44, 147-181.

function Lordered=ordering(L,TL)    % input is are the loadings and the true loadings
m=size(TL,2);        % number of factors
order=NaN(m,1);
sgn=NaN(m,1);
CCmatrix=NaN(m,m);

% calculate the CC between all m*m combinations of factors
for i=1:m
    for i2=1:m
    CCmatrix(i,i2)=cc(TL(:,i),L(:,i2));
    end
end

temp=sort(reshape(abs(CCmatrix),1,m*m),'descend');    % sort all CC's in descending order

for i=1:m*m
    [O,F]=find(abs(CCmatrix)==temp(i));  % find the i-th largest value from the CC matrix
    O=O(1);F=F(1); % take the first one, if there happen to be identical 	s
     if isnan(order(O)) && ~ismember(F,order)
         order(O)=F;
         sgn(O)=sign(CCmatrix(O,F));
         CCmatrix(O,F)=NaN;  % erase this one so that it cannot be found again
     end
end

Lordered=L(:,order);
Lordered=Lordered.*repmat(sgn',size(Lordered,1),1);
